Index: core/xwiki-rendering/xwiki-rendering-macros/xwiki-rendering-macro-error/pom.xml
===================================================================
--- core/xwiki-rendering/xwiki-rendering-macros/xwiki-rendering-macro-error/pom.xml	(revision 0)
+++ core/xwiki-rendering/xwiki-rendering-macros/xwiki-rendering-macro-error/pom.xml	(revision 0)
@@ -0,0 +1,60 @@
+<?xml version="1.0" encoding="UTF-8"?>
+
+<!--
+ *
+ * See the NOTICE file distributed with this work for additional
+ * information regarding copyright ownership.
+ *
+ * This is free software; you can redistribute it and/or modify it
+ * under the terms of the GNU Lesser General Public License as
+ * published by the Free Software Foundation; either version 2.1 of
+ * the License, or (at your option) any later version.
+ *
+ * This software is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
+ * Lesser General Public License for more details.
+ *
+ * You should have received a copy of the GNU Lesser General Public
+ * License along with this software; if not, write to the Free
+ * Software Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA
+ * 02110-1301 USA, or see the FSF site: http://www.fsf.org.
+ *
+-->
+
+<project xmlns="http://maven.apache.org/POM/4.0.0" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xsi:schemaLocation="http://maven.apache.org/POM/4.0.0 http://maven.apache.org/maven-v4_0_0.xsd">
+  <modelVersion>4.0.0</modelVersion>
+  <parent>
+    <groupId>org.xwiki.platform</groupId>
+    <artifactId>xwiki-core-rendering-macros-parent</artifactId>
+    <version>1.8-SNAPSHOT</version>
+  </parent>
+  <artifactId>xwiki-core-rendering-macro-error</artifactId>
+  <name>XWiki Platform - Core - Rendering - Macro - Error</name>
+  <description>XWiki Platform - Core - Rendering - Macro - Error</description>
+  <build>
+    <plugins>
+      <plugin>
+        <groupId>org.apache.maven.plugins</groupId>
+        <artifactId>maven-surefire-plugin</artifactId>
+        <configuration>
+          <includes>
+            <include>**/RenderingTests.java</include>
+          </includes>
+        </configuration>
+      </plugin>
+      <plugin>
+        <!-- Apply the Checkstyle configurations defined in the top level pom.xml file -->
+        <groupId>org.apache.maven.plugins</groupId>
+        <artifactId>maven-checkstyle-plugin</artifactId>
+      </plugin>
+    </plugins>
+  </build>
+  <dependencies>
+    <dependency>
+      <groupId>org.xwiki.platform</groupId>
+      <artifactId>xwiki-core-macro-box</artifactId>
+      <version>${pom.version}</version>
+    </dependency>
+  </dependencies>
+</project>
Index: core/xwiki-rendering/xwiki-rendering-macros/xwiki-rendering-macro-error/src/main/java/org/xwiki/rendering/internal/macro/error/ErrorMacro.java
===================================================================
--- core/xwiki-rendering/xwiki-rendering-macros/xwiki-rendering-macro-error/src/main/java/org/xwiki/rendering/internal/macro/error/ErrorMacro.java	(revision 0)
+++ core/xwiki-rendering/xwiki-rendering-macros/xwiki-rendering-macro-error/src/main/java/org/xwiki/rendering/internal/macro/error/ErrorMacro.java	(revision 0)
@@ -0,0 +1,85 @@
+/*
+ * See the NOTICE file distributed with this work for additional
+ * information regarding copyright ownership.
+ *
+ * This is free software; you can redistribute it and/or modify it
+ * under the terms of the GNU Lesser General Public License as
+ * published by the Free Software Foundation; either version 2.1 of
+ * the License, or (at your option) any later version.
+ *
+ * This software is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
+ * Lesser General Public License for more details.
+ *
+ * You should have received a copy of the GNU Lesser General Public
+ * License along with this software; if not, write to the Free
+ * Software Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA
+ * 02110-1301 USA, or see the FSF site: http://www.fsf.org.
+ */
+package org.xwiki.rendering.internal.macro.error;
+
+import java.util.List;
+
+import org.xwiki.rendering.block.Block;
+import org.xwiki.rendering.macro.AbstractMacro;
+import org.xwiki.rendering.macro.Macro;
+import org.xwiki.rendering.macro.MacroExecutionException;
+import org.xwiki.rendering.macro.box.BoxMacroParameters;
+import org.xwiki.rendering.macro.descriptor.DefaultMacroDescriptor;
+import org.xwiki.rendering.macro.error.ErrorMacroParameters;
+import org.xwiki.rendering.transformation.MacroTransformationContext;
+
+/**
+ * Draw a box around provided content.
+ * 
+ * @param <P> the type of macro parameters bean.
+ * @version $Id: $
+ * @since 1.8
+ */
+public class ErrorMacro<P extends ErrorMacroParameters> extends AbstractMacro<P>
+{
+    /**
+     * The description of the macro.
+     */
+    private static final String DESCRIPTION = "Displays an error message.";
+
+    /**
+     * Injected by the component manager.
+     */
+    private Macro<BoxMacroParameters> boxMacro;
+    
+    /**
+     * Create and initialize the descriptor of the macro.
+     */
+    public ErrorMacro()
+    {
+        super(new DefaultMacroDescriptor(DESCRIPTION, ErrorMacroParameters.class));
+    }
+
+    /**
+     * {@inheritDoc}
+     * 
+     * @see org.xwiki.rendering.macro.Macro#execute(Object, String, MacroTransformationContext)
+     */
+    public List<Block> execute(ErrorMacroParameters parameters, String content, MacroTransformationContext context) 
+        throws MacroExecutionException
+    {
+        BoxMacroParameters boxParameters = new BoxMacroParameters();
+        boxParameters.setCssClass("errormessage");
+        boxParameters.setTitle("(%class=\"messagetype\"%)Error:");
+       
+        List<Block> result = boxMacro.execute(boxParameters, parameters.getText(), context);
+        return result; 
+    }
+
+    /**
+     * {@inheritDoc}
+     * 
+     * @see org.xwiki.rendering.macro.Macro#supportsInlineMode()
+     */
+    public boolean supportsInlineMode()
+    {
+        return false;
+    }
+}
Index: core/xwiki-rendering/xwiki-rendering-macros/xwiki-rendering-macro-error/src/main/java/org/xwiki/rendering/macro/error/ErrorMacroParameters.java
===================================================================
--- core/xwiki-rendering/xwiki-rendering-macros/xwiki-rendering-macro-error/src/main/java/org/xwiki/rendering/macro/error/ErrorMacroParameters.java	(revision 0)
+++ core/xwiki-rendering/xwiki-rendering-macros/xwiki-rendering-macro-error/src/main/java/org/xwiki/rendering/macro/error/ErrorMacroParameters.java	(revision 0)
@@ -0,0 +1,57 @@
+/*
+ * See the NOTICE file distributed with this work for additional
+ * information regarding copyright ownership.
+ *
+ * This is free software; you can redistribute it and/or modify it
+ * under the terms of the GNU Lesser General Public License as
+ * published by the Free Software Foundation; either version 2.1 of
+ * the License, or (at your option) any later version.
+ *
+ * This software is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
+ * Lesser General Public License for more details.
+ *
+ * You should have received a copy of the GNU Lesser General Public
+ * License along with this software; if not, write to the Free
+ * Software Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA
+ * 02110-1301 USA, or see the FSF site: http://www.fsf.org.
+ */
+package org.xwiki.rendering.macro.error;
+
+import org.xwiki.rendering.macro.descriptor.ParameterMandatory;
+import org.apache.commons.lang.StringUtils;
+import org.xwiki.rendering.macro.descriptor.ParameterDescription;
+
+/**
+ * Parameters for macro error.
+ * 
+ * @version $Id: $
+ * @since 1.8
+ */
+public class ErrorMacroParameters
+{
+    /**
+     * Refer to {@link #getText()}.
+     */
+    private String text = StringUtils.EMPTY;
+    
+    /**
+     * @return the text to be displayed in the error message.
+     */
+    public String getText()
+    {
+        return text;
+    }
+
+    /**
+     * @param text - refer to {@link #getText()}
+     */
+    @ParameterDescription("the title which is to be displayed in the the error message")
+    @ParameterMandatory
+    public void setText(String text)
+    {
+        this.text = text;
+    }
+
+}
Index: core/xwiki-rendering/xwiki-rendering-macros/xwiki-rendering-macro-error/src/main/resources/META-INF/plexus/components.xml
===================================================================
--- core/xwiki-rendering/xwiki-rendering-macros/xwiki-rendering-macro-error/src/main/resources/META-INF/plexus/components.xml	(revision 0)
+++ core/xwiki-rendering/xwiki-rendering-macros/xwiki-rendering-macro-error/src/main/resources/META-INF/plexus/components.xml	(revision 0)
@@ -0,0 +1,44 @@
+<?xml version="1.0" encoding="UTF-8"?>
+
+<!--
+ *
+ * See the NOTICE file distributed with this work for additional
+ * information regarding copyright ownership.
+ *
+ * This is free software; you can redistribute it and/or modify it
+ * under the terms of the GNU Lesser General Public License as
+ * published by the Free Software Foundation; either version 2.1 of
+ * the License, or (at your option) any later version.
+ *
+ * This software is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
+ * Lesser General Public License for more details.
+ *
+ * You should have received a copy of the GNU Lesser General Public
+ * License along with this software; if not, write to the Free
+ * Software Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA
+ * 02110-1301 USA, or see the FSF site: http://www.fsf.org.
+ *
+-->
+
+<component-set>
+  <components>
+    <component>
+      <role>org.xwiki.rendering.macro.Macro</role>
+      <role-hint>error</role-hint>
+      <implementation>org.xwiki.rendering.internal.macro.error.ErrorMacro</implementation>
+      <instantiation-strategy>singleton</instantiation-strategy>
+      <configuration>
+        <priority>1000</priority>
+      </configuration>
+      <requirements>
+        <requirement>
+          <role>org.xwiki.rendering.macro.Macro</role>
+          <role-hint>box</role-hint>
+          <field-name>boxMacro</field-name>
+        </requirement>
+      </requirements>
+    </component>
+  </components>
+</component-set>
Index: core/xwiki-rendering/xwiki-rendering-macros/xwiki-rendering-macro-error/src/test/java/org/xwiki/rendering/RenderingTests.java
===================================================================
--- core/xwiki-rendering/xwiki-rendering-macros/xwiki-rendering-macro-error/src/test/java/org/xwiki/rendering/RenderingTests.java	(revision 0)
+++ core/xwiki-rendering/xwiki-rendering-macros/xwiki-rendering-macro-error/src/test/java/org/xwiki/rendering/RenderingTests.java	(revision 0)
@@ -0,0 +1,44 @@
+/*
+ * See the NOTICE file distributed with this work for additional
+ * information regarding copyright ownership.
+ *
+ * This is free software; you can redistribute it and/or modify it
+ * under the terms of the GNU Lesser General Public License as
+ * published by the Free Software Foundation; either version 2.1 of
+ * the License, or (at your option) any later version.
+ *
+ * This software is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
+ * Lesser General Public License for more details.
+ *
+ * You should have received a copy of the GNU Lesser General Public
+ * License along with this software; if not, write to the Free
+ * Software Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA
+ * 02110-1301 USA, or see the FSF site: http://www.fsf.org.
+ */
+package org.xwiki.rendering;
+
+import junit.framework.Test;
+import junit.framework.TestCase;
+
+import org.xwiki.rendering.scaffolding.RenderingPlexusTestSetup;
+import org.xwiki.rendering.scaffolding.RenderingTestSuite;
+
+/**
+ * All Rendering integration tests defined in text files using a special format.
+ * 
+ * @version $Id: $
+ * @since 1.8
+ */
+public class RenderingTests extends TestCase
+{
+    public static Test suite() throws Exception
+    {
+        RenderingTestSuite suite = new RenderingTestSuite("Test Error Macro");
+
+        suite.addTestsFromResource("macroerror1", true);
+
+        return new RenderingPlexusTestSetup(suite);
+    }
+}
Index: core/xwiki-rendering/xwiki-rendering-macros/xwiki-rendering-macro-error/src/test/resources/macroerror1.test
===================================================================
--- core/xwiki-rendering/xwiki-rendering-macros/xwiki-rendering-macro-error/src/test/resources/macroerror1.test	(revision 0)
+++ core/xwiki-rendering/xwiki-rendering-macros/xwiki-rendering-macro-error/src/test/resources/macroerror1.test	(revision 0)
@@ -0,0 +1,38 @@
+.#-----------------------------------------------------
+.input|xwiki/2.0
+.#-----------------------------------------------------
+{{error text="That's a bloody error message"/}}
+.#-----------------------------------------------------
+.expect|xhtml/1.0
+.#-----------------------------------------------------
+<!--startmacro:error|-|text="That's a bloody error message"|-|--><div class="box errormessage"><span class="messagetype">Error:</span><p>That's a bloody error message</p></div><!--stopmacro-->
+.#-----------------------------------------------------
+.expect|xwiki/2.0
+.#-----------------------------------------------------
+{{error text="That's a bloody error message"/}}
+.#-----------------------------------------------------
+.expect|event/1.0
+.#-----------------------------------------------------
+beginDocument
+beginMacroMarker [error] [text=That's a bloody error message] []
+beginXMLNode [div] [class=box errormessage]
+beginFormat: [NONE] [[class]=[messagetype]]
+onWord [Error]
+onSpecialSymbol [:]
+endFormat: [NONE] [[class]=[messagetype]]
+beginParagraph
+onWord [That]
+onSpecialSymbol [']
+onWord [s]
+onSpace
+onWord [a]
+onSpace
+onWord [bloody]
+onSpace
+onWord [error]
+onSpace
+onWord [message]
+endParagraph
+endXMLNode [div] [class=box errormessage]
+endMacroMarker [error] [text=That's a bloody error message] []
+endDocument
\ No newline at end of file
Index: core/xwiki-rendering/xwiki-rendering-macros/xwiki-rendering-macro-warning/pom.xml
===================================================================
--- core/xwiki-rendering/xwiki-rendering-macros/xwiki-rendering-macro-warning/pom.xml	(revision 0)
+++ core/xwiki-rendering/xwiki-rendering-macros/xwiki-rendering-macro-warning/pom.xml	(revision 0)
@@ -0,0 +1,60 @@
+<?xml version="1.0" encoding="UTF-8"?>
+
+<!--
+ *
+ * See the NOTICE file distributed with this work for additional
+ * information regarding copyright ownership.
+ *
+ * This is free software; you can redistribute it and/or modify it
+ * under the terms of the GNU Lesser General Public License as
+ * published by the Free Software Foundation; either version 2.1 of
+ * the License, or (at your option) any later version.
+ *
+ * This software is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
+ * Lesser General Public License for more details.
+ *
+ * You should have received a copy of the GNU Lesser General Public
+ * License along with this software; if not, write to the Free
+ * Software Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA
+ * 02110-1301 USA, or see the FSF site: http://www.fsf.org.
+ *
+-->
+
+<project xmlns="http://maven.apache.org/POM/4.0.0" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xsi:schemaLocation="http://maven.apache.org/POM/4.0.0 http://maven.apache.org/maven-v4_0_0.xsd">
+  <modelVersion>4.0.0</modelVersion>
+  <parent>
+    <groupId>org.xwiki.platform</groupId>
+    <artifactId>xwiki-core-rendering-macros-parent</artifactId>
+    <version>1.8-SNAPSHOT</version>
+  </parent>
+  <artifactId>xwiki-core-rendering-macro-warning</artifactId>
+  <name>XWiki Platform - Core - Rendering - Macro - Warning</name>
+  <description>XWiki Platform - Core - Rendering - Macro - Warning</description>
+  <build>
+    <plugins>
+      <plugin>
+        <groupId>org.apache.maven.plugins</groupId>
+        <artifactId>maven-surefire-plugin</artifactId>
+        <configuration>
+          <includes>
+            <include>**/RenderingTests.java</include>
+          </includes>
+        </configuration>
+      </plugin>
+      <plugin>
+        <!-- Apply the Checkstyle configurations defined in the top level pom.xml file -->
+        <groupId>org.apache.maven.plugins</groupId>
+        <artifactId>maven-checkstyle-plugin</artifactId>
+      </plugin>
+    </plugins>
+  </build>
+  <dependencies>
+    <dependency>
+      <groupId>org.xwiki.platform</groupId>
+      <artifactId>xwiki-core-macro-box</artifactId>
+      <version>${pom.version}</version>
+    </dependency>
+  </dependencies>
+</project>
Index: core/xwiki-rendering/xwiki-rendering-macros/xwiki-rendering-macro-warning/src/main/java/org/xwiki/rendering/internal/macro/warning/WarningMacro.java
===================================================================
--- core/xwiki-rendering/xwiki-rendering-macros/xwiki-rendering-macro-warning/src/main/java/org/xwiki/rendering/internal/macro/warning/WarningMacro.java	(revision 0)
+++ core/xwiki-rendering/xwiki-rendering-macros/xwiki-rendering-macro-warning/src/main/java/org/xwiki/rendering/internal/macro/warning/WarningMacro.java	(revision 0)
@@ -0,0 +1,85 @@
+/*
+ * See the NOTICE file distributed with this work for additional
+ * information regarding copyright ownership.
+ *
+ * This is free software; you can redistribute it and/or modify it
+ * under the terms of the GNU Lesser General Public License as
+ * published by the Free Software Foundation; either version 2.1 of
+ * the License, or (at your option) any later version.
+ *
+ * This software is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
+ * Lesser General Public License for more details.
+ *
+ * You should have received a copy of the GNU Lesser General Public
+ * License along with this software; if not, write to the Free
+ * Software Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA
+ * 02110-1301 USA, or see the FSF site: http://www.fsf.org.
+ */
+package org.xwiki.rendering.internal.macro.warning;
+
+import java.util.List;
+
+import org.xwiki.rendering.block.Block;
+import org.xwiki.rendering.macro.AbstractMacro;
+import org.xwiki.rendering.macro.Macro;
+import org.xwiki.rendering.macro.MacroExecutionException;
+import org.xwiki.rendering.macro.box.BoxMacroParameters;
+import org.xwiki.rendering.macro.descriptor.DefaultMacroDescriptor;
+import org.xwiki.rendering.macro.warning.WarningMacroParameters;
+import org.xwiki.rendering.transformation.MacroTransformationContext;
+
+/**
+ * Draw a box around provided content.
+ * 
+ * @param <P> the type of macro parameters bean.
+ * @version $Id: $
+ * @since 1.8
+ */
+public class WarningMacro<P extends WarningMacroParameters> extends AbstractMacro<P>
+{
+    /**
+     * The description of the macro.
+     */
+    private static final String DESCRIPTION = "Displays an warning message.";
+
+    /**
+     * Injected by the component manager.
+     */
+    private Macro<BoxMacroParameters> boxMacro;
+    
+    /**
+     * Create and initialize the descriptor of the macro.
+     */
+    public WarningMacro()
+    {
+        super(new DefaultMacroDescriptor(DESCRIPTION, WarningMacroParameters.class));
+    }
+
+    /**
+     * {@inheritDoc}
+     * 
+     * @see org.xwiki.rendering.macro.Macro#execute(Object, String, MacroTransformationContext)
+     */
+    public List<Block> execute(WarningMacroParameters parameters, String content, MacroTransformationContext context) 
+        throws MacroExecutionException
+    {
+        BoxMacroParameters boxParameters = new BoxMacroParameters();
+        boxParameters.setCssClass("warningmessage");
+        boxParameters.setTitle("(%class=\"messagetype\"%)Warning:");
+       
+        List<Block> result = boxMacro.execute(boxParameters, parameters.getText(), context);
+        return result; 
+    }
+
+    /**
+     * {@inheritDoc}
+     * 
+     * @see org.xwiki.rendering.macro.Macro#supportsInlineMode()
+     */
+    public boolean supportsInlineMode()
+    {
+        return false;
+    }
+}
Index: core/xwiki-rendering/xwiki-rendering-macros/xwiki-rendering-macro-warning/src/main/java/org/xwiki/rendering/macro/warning/WarningMacroParameters.java
===================================================================
--- core/xwiki-rendering/xwiki-rendering-macros/xwiki-rendering-macro-warning/src/main/java/org/xwiki/rendering/macro/warning/WarningMacroParameters.java	(revision 0)
+++ core/xwiki-rendering/xwiki-rendering-macros/xwiki-rendering-macro-warning/src/main/java/org/xwiki/rendering/macro/warning/WarningMacroParameters.java	(revision 0)
@@ -0,0 +1,57 @@
+/*
+ * See the NOTICE file distributed with this work for additional
+ * information regarding copyright ownership.
+ *
+ * This is free software; you can redistribute it and/or modify it
+ * under the terms of the GNU Lesser General Public License as
+ * published by the Free Software Foundation; either version 2.1 of
+ * the License, or (at your option) any later version.
+ *
+ * This software is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
+ * Lesser General Public License for more details.
+ *
+ * You should have received a copy of the GNU Lesser General Public
+ * License along with this software; if not, write to the Free
+ * Software Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA
+ * 02110-1301 USA, or see the FSF site: http://www.fsf.org.
+ */
+package org.xwiki.rendering.macro.warning;
+
+import org.xwiki.rendering.macro.descriptor.ParameterMandatory;
+import org.apache.commons.lang.StringUtils;
+import org.xwiki.rendering.macro.descriptor.ParameterDescription;
+
+/**
+ * Parameters for macro warning.
+ * 
+ * @version $Id: $
+ * @since 1.8
+ */
+public class WarningMacroParameters
+{
+    /**
+     * Refer to {@link #getText()}.
+     */
+    private String text = StringUtils.EMPTY;
+    
+    /**
+     * @return the text to be displayed in the warning message.
+     */
+    public String getText()
+    {
+        return text;
+    }
+
+    /**
+     * @param text - refer to {@link #getText()}
+     */
+    @ParameterDescription("the title which is to be displayed in the the warning message")
+    @ParameterMandatory
+    public void setText(String text)
+    {
+        this.text = text;
+    }
+
+}
Index: core/xwiki-rendering/xwiki-rendering-macros/xwiki-rendering-macro-warning/src/main/resources/META-INF/plexus/components.xml
===================================================================
--- core/xwiki-rendering/xwiki-rendering-macros/xwiki-rendering-macro-warning/src/main/resources/META-INF/plexus/components.xml	(revision 0)
+++ core/xwiki-rendering/xwiki-rendering-macros/xwiki-rendering-macro-warning/src/main/resources/META-INF/plexus/components.xml	(revision 0)
@@ -0,0 +1,44 @@
+<?xml version="1.0" encoding="UTF-8"?>
+
+<!--
+ *
+ * See the NOTICE file distributed with this work for additional
+ * information regarding copyright ownership.
+ *
+ * This is free software; you can redistribute it and/or modify it
+ * under the terms of the GNU Lesser General Public License as
+ * published by the Free Software Foundation; either version 2.1 of
+ * the License, or (at your option) any later version.
+ *
+ * This software is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
+ * Lesser General Public License for more details.
+ *
+ * You should have received a copy of the GNU Lesser General Public
+ * License along with this software; if not, write to the Free
+ * Software Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA
+ * 02110-1301 USA, or see the FSF site: http://www.fsf.org.
+ *
+-->
+
+<component-set>
+  <components>
+    <component>
+      <role>org.xwiki.rendering.macro.Macro</role>
+      <role-hint>warning</role-hint>
+      <implementation>org.xwiki.rendering.internal.macro.warning.WarningMacro</implementation>
+      <instantiation-strategy>singleton</instantiation-strategy>
+      <configuration>
+        <priority>1000</priority>
+      </configuration>
+      <requirements>
+        <requirement>
+          <role>org.xwiki.rendering.macro.Macro</role>
+          <role-hint>box</role-hint>
+          <field-name>boxMacro</field-name>
+        </requirement>
+      </requirements>
+    </component>
+  </components>
+</component-set>
Index: core/xwiki-rendering/xwiki-rendering-macros/xwiki-rendering-macro-warning/src/test/java/org/xwiki/rendering/RenderingTests.java
===================================================================
--- core/xwiki-rendering/xwiki-rendering-macros/xwiki-rendering-macro-warning/src/test/java/org/xwiki/rendering/RenderingTests.java	(revision 0)
+++ core/xwiki-rendering/xwiki-rendering-macros/xwiki-rendering-macro-warning/src/test/java/org/xwiki/rendering/RenderingTests.java	(revision 0)
@@ -0,0 +1,44 @@
+/*
+ * See the NOTICE file distributed with this work for additional
+ * information regarding copyright ownership.
+ *
+ * This is free software; you can redistribute it and/or modify it
+ * under the terms of the GNU Lesser General Public License as
+ * published by the Free Software Foundation; either version 2.1 of
+ * the License, or (at your option) any later version.
+ *
+ * This software is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
+ * Lesser General Public License for more details.
+ *
+ * You should have received a copy of the GNU Lesser General Public
+ * License along with this software; if not, write to the Free
+ * Software Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA
+ * 02110-1301 USA, or see the FSF site: http://www.fsf.org.
+ */
+package org.xwiki.rendering;
+
+import junit.framework.Test;
+import junit.framework.TestCase;
+
+import org.xwiki.rendering.scaffolding.RenderingPlexusTestSetup;
+import org.xwiki.rendering.scaffolding.RenderingTestSuite;
+
+/**
+ * All Rendering integration tests defined in text files using a special format.
+ * 
+ * @version $Id: RenderingTests.java 14966 2008-12-30 12:39:26Z tmortagne $
+ * @since 1.7M3
+ */
+public class RenderingTests extends TestCase
+{
+    public static Test suite() throws Exception
+    {
+        RenderingTestSuite suite = new RenderingTestSuite("Test Warning Macro");
+
+        suite.addTestsFromResource("macrowarning1", true);
+
+        return new RenderingPlexusTestSetup(suite);
+    }
+}
Index: core/xwiki-rendering/xwiki-rendering-macros/xwiki-rendering-macro-warning/src/test/resources/macrowarning1.test
===================================================================
--- core/xwiki-rendering/xwiki-rendering-macros/xwiki-rendering-macro-warning/src/test/resources/macrowarning1.test	(revision 0)
+++ core/xwiki-rendering/xwiki-rendering-macros/xwiki-rendering-macro-warning/src/test/resources/macrowarning1.test	(revision 0)
@@ -0,0 +1,38 @@
+.#-----------------------------------------------------
+.input|xwiki/2.0
+.#-----------------------------------------------------
+{{warning text="That's a bloody warning message"/}}
+.#-----------------------------------------------------
+.expect|xhtml/1.0
+.#-----------------------------------------------------
+<!--startmacro:warning|-|text="That's a bloody warning message"|-|--><div class="box warningmessage"><span class="messagetype">Warning:</span><p>That's a bloody warning message</p></div><!--stopmacro-->
+.#-----------------------------------------------------
+.expect|xwiki/2.0
+.#-----------------------------------------------------
+{{warning text="That's a bloody warning message"/}}
+.#-----------------------------------------------------
+.expect|event/1.0
+.#-----------------------------------------------------
+beginDocument
+beginMacroMarker [warning] [text=That's a bloody warning message] []
+beginXMLNode [div] [class=box warningmessage]
+beginFormat: [NONE] [[class]=[messagetype]]
+onWord [Warning]
+onSpecialSymbol [:]
+endFormat: [NONE] [[class]=[messagetype]]
+beginParagraph
+onWord [That]
+onSpecialSymbol [']
+onWord [s]
+onSpace
+onWord [a]
+onSpace
+onWord [bloody]
+onSpace
+onWord [warning]
+onSpace
+onWord [message]
+endParagraph
+endXMLNode [div] [class=box warningmessage]
+endMacroMarker [warning] [text=That's a bloody warning message] []
+endDocument
\ No newline at end of file